<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 * Supports a modal article picker.
 *
 * @since  1.6
 */

if (version_compare(JVERSION, "4.0.0-alpha10", "ge")) {
    class JFormFieldModal_Article_BL extends Joomla\Component\Content\Administrator\Field\Modal\ArticleField
{
	/**
	 * The form field type.
	 *
	 * @var    string
	 * @since  1.6
	 */
	protected $type = 'Modal_Article_BL';
        /**
         * Method to get the field input markup.
         *
         * @return  string  The field input markup.
         *
         * @since   1.6
         */

        // public function __construct() {
        public function __construct($id_article_book = 0) {
            
            $this->name = 'OnlineArticle';
            
            $allowNew = $this->element['new'] = 'true';
            $allowEdit   = $this->element['edit'] = 'true';
            $allowClear  = $this->element['clear'] = 'true';
            $allowSelect = $this->element['select'] = 'true';

            if ($id_article_book > 0) {
                $this->value =  $id_article_book ;
                $this->id =  $id_article_book ;
            }
        }
        
        public function getInput()
        {
        
            $this->name = 'OnlineArticle';                                      
            $this->element['propagate'] = false;
            
            return parent::getInput();
        }

        /**
         * Method to get the field label markup.
         *
         * @return  string  The field label markup.
         *
         * @since   3.4
         */
        public function getLabel()
        {
            return str_replace($this->id, $this->id . '_id', parent::getLabel());
        }
    }
} else {
    class JFormFieldModal_Article_BL extends JFormFieldModal_Article
    {

        /**
         * The form field type.
         *
         * @var    string
         * @since  1.6
         */
        protected $type = 'Modal_Article_BL';
	/**
	 * Method to get the field input markup.
         *
	 * @return  string  The field input markup.
	 *
	 * @since   1.6

	 */
    // public function __construct() {
	public function __construct($id_article_book = 0) {
		
		$this->name = 'OnlineArticle';
		
		$allowNew = $this->element['new'] = 'true';
		$allowEdit   = $this->element['edit'] = 'true';
		$allowClear  = $this->element['clear'] = 'true';
		$allowSelect = $this->element['select'] = 'true';

        if ($id_article_book > 0) {
            $this->value =  $id_article_book ;
            $this->id =  $id_article_book ;
        }
	}


	public function getInput()
	{
	
		$this->name = 'OnlineArticle';										
		
		return parent::getInput();
	}

	/**
	 * Method to get the field label markup.
	 *
	 * @return  string  The field label markup.
	 *
	 * @since   3.4
	 */
	public function getLabel()
	{
		return str_replace($this->id, $this->id . '_id', parent::getLabel());
        }
	}
}
